import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { Button } from 'antd-msb';
import classNames from 'classnames';
import { DownOutlined, HumburgerOutlined } from "msb-icons-svg/es/src";
import React, { useState } from 'react';
import { ConfigContext } from '../config-provider';
import Divider from '../divider';
import Drawer from '../drawer';
import { Col, Row } from '../grid';
import useBreakpoint from '../grid/hooks/useBreakpoint';
import Layout from '../layout';
import Menu from '../menu';
import Space from '../space';

var Header = function Header(_a) {
  var customizePrefixCls = _a.prefixCls,
      props = __rest(_a, ["prefixCls"]);

  var className = props.className,
      btnActions = props.btnActions,
      avatar = props.avatar,
      menuItems = props.menuItems,
      _props$position = props.position,
      position = _props$position === void 0 ? 'fixed' : _props$position;

  var _React$useContext = React.useContext(ConfigContext),
      getPrefixCls = _React$useContext.getPrefixCls;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      openMenu = _useState2[0],
      setOpenMenu = _useState2[1];

  var screens = useBreakpoint();
  var prefixCls = getPrefixCls('header-msb', customizePrefixCls);
  var classString = classNames("".concat(prefixCls), _defineProperty({}, "".concat(prefixCls, "-mobile"), !screens.lg), _defineProperty({}, "".concat(prefixCls, "-fixed"), position === 'fixed'), className);

  var toggleMobileMenu = function toggleMobileMenu() {
    setOpenMenu(!openMenu);
  };

  var menus = /*#__PURE__*/React.createElement(Menu, {
    className: "",
    mode: screens.lg ? 'horizontal' : 'inline',
    rootClassName: "".concat(prefixCls, "-menu-items"),
    items: menuItems,
    expandIcon: /*#__PURE__*/React.createElement(DownOutlined, null)
  });
  var logo = /*#__PURE__*/React.createElement("div", {
    className: "logo"
  }, /*#__PURE__*/React.createElement("a", {
    href: "/"
  }, /*#__PURE__*/React.createElement("img", {
    alt: "logo",
    src: "https://common-static-files-public.s3.ap-southeast-1.amazonaws.com/design-system/logo_msb.svg"
  })));
  return /*#__PURE__*/React.createElement(Layout.Header, {
    className: classString
  }, /*#__PURE__*/React.createElement(Row, {
    justify: "space-between",
    wrap: false
  }, /*#__PURE__*/React.createElement(Col, {
    span: 3
  }, logo), /*#__PURE__*/React.createElement(Col, {
    span: 21,
    className: "".concat(prefixCls, "-menus")
  }, screens.lg ? /*#__PURE__*/React.createElement(React.Fragment, null, menus, btnActions && /*#__PURE__*/React.createElement("div", {
    className: "space-ml-16"
  }, /*#__PURE__*/React.createElement(Space, null, btnActions)), avatar && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Divider, {
    className: "space-mx-24 ".concat(prefixCls, "-avatar-divider"),
    type: "vertical"
  }), ' ', /*#__PURE__*/React.createElement("div", null, avatar))) : /*#__PURE__*/React.createElement(Button, {
    icon: /*#__PURE__*/React.createElement(HumburgerOutlined, null),
    className: "".concat(prefixCls, "-mobile-humburger"),
    shape: "circle",
    onClick: toggleMobileMenu
  }))), /*#__PURE__*/React.createElement(Drawer, {
    width: "100%",
    title: logo,
    placement: "left",
    onClose: toggleMobileMenu,
    open: openMenu,
    key: "left",
    className: classString
  }, avatar && /*#__PURE__*/React.createElement("div", {
    className: "space-p-16 ".concat(prefixCls, "-mobile-avatar")
  }, avatar), menus, btnActions && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-mobile-btn-actions")
  }, btnActions))));
};

export default Header;