import _extends from "@babel/runtime/helpers/esm/extends";

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import classNames from 'classnames';
import * as React from 'react';
import { ConfigContext } from '../config-provider';

var MenuList = function MenuList(_a) {
  var customizePrefixCls = _a.prefixCls,
      className = _a.className,
      prefixIcon = _a.prefixIcon,
      suffixIcon = _a.suffixIcon,
      title = _a.title,
      onClick = _a.onClick,
      restProps = __rest(_a, ["prefixCls", "className", "prefixIcon", "suffixIcon", "title", "onClick"]);

  var _React$useContext = React.useContext(ConfigContext),
      getPrefixCls = _React$useContext.getPrefixCls;

  var handleClick = function handleClick(e) {
    onClick === null || onClick === void 0 ? void 0 : onClick(e);
  };

  var prefixCls = getPrefixCls('menu-list', customizePrefixCls);
  return /*#__PURE__*/React.createElement("span", _extends({}, restProps, {
    className: classNames("".concat(prefixCls), className),
    onClick: handleClick
  }), /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-item"))
  }, prefixIcon && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-prefix-icon")
  }, prefixIcon), title && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title")
  }, title), suffixIcon && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-suffix-icon")
  }, suffixIcon)));
};

if (process.env.NODE_ENV !== 'production') {
  MenuList.displayName = 'MenuList';
}

export default MenuList;