import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _extends from "@babel/runtime/helpers/esm/extends";
import classNames from 'classnames';
import * as React from 'react';
import { ConfigContext } from '../config-provider';
import { PresetColorTypes, PresetStatusColorTypes } from '../_util/colors';
import Wave from '../_util/wave';
var PresetColorRegex = new RegExp("^(".concat(PresetColorTypes.join('|'), ")(-inverse)?$"));
var PresetStatusColorRegex = new RegExp("^(".concat(PresetStatusColorTypes.join('|'), ")$"));

var InternalStatus = function InternalStatus(_ref, ref) {
  var _classNames;

  var customizePrefixCls = _ref.prefixCls,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      type = _ref.type;

  var _React$useContext = React.useContext(ConfigContext),
      getPrefixCls = _React$useContext.getPrefixCls,
      direction = _React$useContext.direction;

  var isPresetColor = function isPresetColor() {
    if (!type) {
      return false;
    }

    return PresetColorRegex.test(type) || PresetStatusColorRegex.test(type);
  };

  var statusStyle = _extends({
    backgroundColor: type && !isPresetColor() ? type : undefined
  }, style);

  var presetColor = isPresetColor();
  var prefixCls = getPrefixCls('status', customizePrefixCls);
  var statusClassName = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(type), presetColor), _defineProperty(_classNames, "".concat(prefixCls, "-has-color"), type && !presetColor), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === 'rtl'), _classNames), className);
  var statusNode = /*#__PURE__*/React.createElement("span", {
    ref: ref,
    className: statusClassName,
    style: statusStyle
  }, children);
  return /*#__PURE__*/React.createElement(Wave, null, statusNode);
};

var Status = /*#__PURE__*/React.forwardRef(InternalStatus);

if (process.env.NODE_ENV !== 'production') {
  Status.displayName = 'Status';
}

export default Status;