import _extends from "@babel/runtime/helpers/esm/extends";
import _typeof from "@babel/runtime/helpers/esm/typeof";

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import omit from "rc-util/es/omit";
import * as React from 'react';
import { tupleNum } from '../_util/type';
import warning from '../_util/warning';
import Base from './Base';
var TITLE_ELE_LIST = tupleNum(1, 2, 3, 4);

var Note = function Note(_a, ref) {
  var _a$level = _a.level,
      level = _a$level === void 0 ? 1 : _a$level,
      _a$block = _a.block,
      block = _a$block === void 0 ? true : _a$block,
      ellipsis = _a.ellipsis,
      className = _a.className,
      restProps = __rest(_a, ["level", "block", "ellipsis", "className"]);

  var mergedEllipsis = React.useMemo(function () {
    if (ellipsis && _typeof(ellipsis) === 'object') {
      return omit(ellipsis, ['expandable', 'rows']);
    }

    return ellipsis;
  }, [ellipsis]);
  process.env.NODE_ENV !== "production" ? warning(_typeof(ellipsis) !== 'object' || !ellipsis || !('expandable' in ellipsis) && !('rows' in ellipsis), 'Typography.Text', '`ellipsis` do not support `expandable` or `rows` props.') : void 0;
  return /*#__PURE__*/React.createElement(Base, _extends({
    ref: ref
  }, restProps, {
    className: "typography-note-".concat(level, " ").concat(className || ''),
    ellipsis: mergedEllipsis,
    component: block ? 'div' : 'span'
  }));
};

export default /*#__PURE__*/React.forwardRef(Note);