import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _extends from "@babel/runtime/helpers/esm/extends";

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import classNames from 'classnames';
import * as React from 'react';
import { tupleNum } from '../_util/type';
import warning from '../_util/warning';
import Base from './Base';
var TITLE_ELE_LIST = tupleNum(1, 2, 3, 4, 5, 6);

var Title = function Title(props, ref) {
  var _classNames;

  var _props$block = props.block,
      block = _props$block === void 0 ? true : _props$block,
      _props$level = props.level,
      level = _props$level === void 0 ? 1 : _props$level,
      _props$version = props.version,
      version = _props$version === void 0 ? 1 : _props$version,
      className = props.className,
      restProps = __rest(props, ["block", "level", "version", "className"]);

  var component;

  if (TITLE_ELE_LIST.indexOf(level) !== -1) {
    component = block ? "div" : "span";
  } else {
    process.env.NODE_ENV !== "production" ? warning(false, 'Typography.Title', 'Title only accept `1 | 2 | 3 | 4 | 5` as `level` value. And `5` need 4.6.0+ version.') : void 0;
    component = block ? "div" : "span";
  }

  return /*#__PURE__*/React.createElement(Base, _extends({
    ref: ref
  }, restProps, {
    className: classNames((_classNames = {}, _defineProperty(_classNames, "typography-title-".concat(level), version === 1), _defineProperty(_classNames, "typography-title-v2", version === 2), _classNames), className),
    component: component
  }));
};

export default /*#__PURE__*/React.forwardRef(Title);