"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _antdMsb = require("antd-msb");

var _classnames = _interopRequireDefault(require("classnames"));

var _src = require("msb-icons-svg/lib/src");

var _react = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

var _divider = _interopRequireDefault(require("../divider"));

var _drawer = _interopRequireDefault(require("../drawer"));

var _grid = require("../grid");

var _useBreakpoint = _interopRequireDefault(require("../grid/hooks/useBreakpoint"));

var _layout = _interopRequireDefault(require("../layout"));

var _menu = _interopRequireDefault(require("../menu"));

var _space = _interopRequireDefault(require("../space"));

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var Header = function Header(_a) {
  var customizePrefixCls = _a.prefixCls,
      props = __rest(_a, ["prefixCls"]);

  var className = props.className,
      btnActions = props.btnActions,
      avatar = props.avatar,
      menuItems = props.menuItems,
      _props$position = props.position,
      position = _props$position === void 0 ? 'fixed' : _props$position;

  var _React$useContext = _react["default"].useContext(_configProvider.ConfigContext),
      getPrefixCls = _React$useContext.getPrefixCls;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      openMenu = _useState2[0],
      setOpenMenu = _useState2[1];

  var screens = (0, _useBreakpoint["default"])();
  var prefixCls = getPrefixCls('header-msb', customizePrefixCls);
  var classString = (0, _classnames["default"])("".concat(prefixCls), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-mobile"), !screens.lg), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-fixed"), position === 'fixed'), className);

  var toggleMobileMenu = function toggleMobileMenu() {
    setOpenMenu(!openMenu);
  };

  var menus = /*#__PURE__*/_react["default"].createElement(_menu["default"], {
    className: "",
    mode: screens.lg ? 'horizontal' : 'inline',
    rootClassName: "".concat(prefixCls, "-menu-items"),
    items: menuItems,
    expandIcon: /*#__PURE__*/_react["default"].createElement(_src.DownOutlined, null)
  });

  var logo = /*#__PURE__*/_react["default"].createElement("div", {
    className: "logo"
  }, /*#__PURE__*/_react["default"].createElement("a", {
    href: "/"
  }, /*#__PURE__*/_react["default"].createElement("img", {
    alt: "logo",
    src: "https://common-static-files-public.s3.ap-southeast-1.amazonaws.com/design-system/logo_msb.svg"
  })));

  return /*#__PURE__*/_react["default"].createElement(_layout["default"].Header, {
    className: classString
  }, /*#__PURE__*/_react["default"].createElement(_grid.Row, {
    justify: "space-between",
    wrap: false
  }, /*#__PURE__*/_react["default"].createElement(_grid.Col, {
    span: 3
  }, logo), /*#__PURE__*/_react["default"].createElement(_grid.Col, {
    span: 21,
    className: "".concat(prefixCls, "-menus")
  }, screens.lg ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, menus, btnActions && /*#__PURE__*/_react["default"].createElement("div", {
    className: "space-ml-16"
  }, /*#__PURE__*/_react["default"].createElement(_space["default"], null, btnActions)), avatar && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_divider["default"], {
    className: "space-mx-24 ".concat(prefixCls, "-avatar-divider"),
    type: "vertical"
  }), ' ', /*#__PURE__*/_react["default"].createElement("div", null, avatar))) : /*#__PURE__*/_react["default"].createElement(_antdMsb.Button, {
    icon: /*#__PURE__*/_react["default"].createElement(_src.HumburgerOutlined, null),
    className: "".concat(prefixCls, "-mobile-humburger"),
    shape: "circle",
    onClick: toggleMobileMenu
  }))), /*#__PURE__*/_react["default"].createElement(_drawer["default"], {
    width: "100%",
    title: logo,
    placement: "left",
    onClose: toggleMobileMenu,
    open: openMenu,
    key: "left",
    className: classString
  }, avatar && /*#__PURE__*/_react["default"].createElement("div", {
    className: "space-p-16 ".concat(prefixCls, "-mobile-avatar")
  }, avatar), menus, btnActions && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_divider["default"], null), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-mobile-btn-actions")
  }, btnActions))));
};

var _default = Header;
exports["default"] = _default;