"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classnames = _interopRequireDefault(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

var _colors = require("../_util/colors");

var _wave = _interopRequireDefault(require("../_util/wave"));

var PresetColorRegex = new RegExp("^(".concat(_colors.PresetColorTypes.join('|'), ")(-inverse)?$"));
var PresetStatusColorRegex = new RegExp("^(".concat(_colors.PresetStatusColorTypes.join('|'), ")$"));

var InternalStatus = function InternalStatus(_ref, ref) {
  var _classNames;

  var customizePrefixCls = _ref.prefixCls,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      type = _ref.type;

  var _React$useContext = React.useContext(_configProvider.ConfigContext),
      getPrefixCls = _React$useContext.getPrefixCls,
      direction = _React$useContext.direction;

  var isPresetColor = function isPresetColor() {
    if (!type) {
      return false;
    }

    return PresetColorRegex.test(type) || PresetStatusColorRegex.test(type);
  };

  var statusStyle = (0, _extends2["default"])({
    backgroundColor: type && !isPresetColor() ? type : undefined
  }, style);
  var presetColor = isPresetColor();
  var prefixCls = getPrefixCls('status', customizePrefixCls);
  var statusClassName = (0, _classnames["default"])(prefixCls, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-").concat(type), presetColor), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-has-color"), type && !presetColor), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-rtl"), direction === 'rtl'), _classNames), className);
  var statusNode = /*#__PURE__*/React.createElement("span", {
    ref: ref,
    className: statusClassName,
    style: statusStyle
  }, children);
  return /*#__PURE__*/React.createElement(_wave["default"], null, statusNode);
};

var Status = /*#__PURE__*/React.forwardRef(InternalStatus);

if (process.env.NODE_ENV !== 'production') {
  Status.displayName = 'Status';
}

var _default = Status;
exports["default"] = _default;