"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classnames = _interopRequireDefault(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _type = require("../_util/type");

var _warning = _interopRequireDefault(require("../_util/warning"));

var _Base = _interopRequireDefault(require("./Base"));

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var TITLE_ELE_LIST = (0, _type.tupleNum)(1, 2, 3, 4, 5, 6);

var Title = function Title(props, ref) {
  var _classNames;

  var _props$block = props.block,
      block = _props$block === void 0 ? true : _props$block,
      _props$level = props.level,
      level = _props$level === void 0 ? 1 : _props$level,
      _props$version = props.version,
      version = _props$version === void 0 ? 1 : _props$version,
      className = props.className,
      restProps = __rest(props, ["block", "level", "version", "className"]);

  var component;

  if (TITLE_ELE_LIST.indexOf(level) !== -1) {
    component = block ? "div" : "span";
  } else {
    process.env.NODE_ENV !== "production" ? (0, _warning["default"])(false, 'Typography.Title', 'Title only accept `1 | 2 | 3 | 4 | 5` as `level` value. And `5` need 4.6.0+ version.') : void 0;
    component = block ? "div" : "span";
  }

  return /*#__PURE__*/React.createElement(_Base["default"], (0, _extends2["default"])({
    ref: ref
  }, restProps, {
    className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "typography-title-".concat(level), version === 1), (0, _defineProperty2["default"])(_classNames, "typography-title-v2", version === 2), _classNames), className),
    component: component
  }));
};

var _default = /*#__PURE__*/React.forwardRef(Title);

exports["default"] = _default;