"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PreviewFileType = exports.PatternValidate = void 0;
var PreviewFileType;
exports.PreviewFileType = PreviewFileType;

(function (PreviewFileType) {
  PreviewFileType["IMAGE"] = "IMAGE";
  PreviewFileType["PDF"] = "PDF";
  PreviewFileType["WORD"] = "WORD";
  PreviewFileType["EXCEL"] = "EXCEL";
  PreviewFileType["XML"] = "XML";
  PreviewFileType["OTHER"] = "OTHER";
})(PreviewFileType || (exports.PreviewFileType = PreviewFileType = {}));

var pdfExtensionPattern = /[^\\s]+(.*?)\.(pdf|PDF)$/;
var xmlExtensionPattern = /[^\\s]+(.*?)\.(xml|XML)$/;
var imageExtensionPattern = /[^\\s]+(.*?)\.(jpg|jpeg|png|gif|JPG|JPEG|PNG|GIF)$/;
var wordExtensionPattern = /[^\\s]+(.*?)\.(doc|docx|dot|dotx|DOC|DOCX|DOT|DOTX)$/;
var excelsExtensionPattern = /[^\\s]+(.*?)\.(xls|xlsx|xlsm|csv|XLS|XLSX|XLSM|CSV)$/;
var PatternValidate = {
  pdfExtensionPattern: pdfExtensionPattern,
  xmlExtensionPattern: xmlExtensionPattern,
  imageExtensionPattern: imageExtensionPattern,
  wordExtensionPattern: wordExtensionPattern,
  excelsExtensionPattern: excelsExtensionPattern
};
exports.PatternValidate = PatternValidate;